/*----- PROTECTED REGION ID(JDeviceForEvent.java) ENABLED START -----*/
//=============================================================================
//
// file :        JDeviceForEvent.java
//
// description : Java source for the JDeviceForEvent class and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               JDeviceForEvent are implemented in this file.
//
// project :     Device For Event Java
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.java

package org.tango.jdeviceforevent;

/*----- PROTECTED REGION ID(JDeviceForEvent.imports) ENABLED START -----*/
import fr.esrf.TangoApi.events.ZmqEventConsumer;
import fr.esrf.TangoDs.Util;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.ext.XLogger;
import org.slf4j.ext.XLoggerFactory;
import org.tango.DeviceState;
import org.tango.server.InvocationContext;
import org.tango.server.ServerManager;
import org.tango.server.annotation.AroundInvoke;
import org.tango.server.annotation.Attribute;
import org.tango.server.annotation.AttributeProperties;
import org.tango.server.annotation.ClassProperty;
import org.tango.server.annotation.Command;
import org.tango.server.annotation.Delete;
import org.tango.server.annotation.Device;
import org.tango.server.annotation.DeviceProperty;
import org.tango.server.annotation.DynamicManagement;
import org.tango.server.annotation.Init;
import org.tango.server.annotation.State;
import org.tango.server.annotation.StateMachine;
import org.tango.server.annotation.Status;
import org.tango.server.dynamic.DynamicManager;
import org.tango.utils.DevFailedUtils;

//	Import Tango IDL types
import fr.esrf.Tango.*;

import java.io.File;

/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.imports

/**
 *  JDeviceForEvent class description:
 *    Java Device generating Events
 */

@Device
public class JDeviceForEvent {

    private static final Logger logger = LoggerFactory.getLogger(JDeviceForEvent.class);
    private static final XLogger xlogger = XLoggerFactory.getXLogger(JDeviceForEvent.class);
	//========================================================
	//	Programmer's data members
	//========================================================
    /*----- PROTECTED REGION ID(JDeviceForEvent.variables) ENABLED START -----*/
    
    //	Put static variables here
    
    /*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.variables
	/*----- PROTECTED REGION ID(JDeviceForEvent.private) ENABLED START -----*/
	
	//	Put private variables here
	
	/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.private

	//========================================================
	//	Property data members and related methods
	//========================================================


	//========================================================
	//	Miscellaneous methods
	//========================================================
	/**
	 * Initialize the device.
	 * 
	 * @throws DevFailed if something fails during the device initialization.
	 */
	@Init(lazyLoading = false)
	public final void initDevice() throws DevFailed {
		xlogger.entry();
		logger.debug("init");
		/*----- PROTECTED REGION ID(JDeviceForEvent.initDevice) ENABLED START -----*/
		
		//	Put your device initialization code here

		
		/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.initDevice
		xlogger.exit();
	}

	/**
	 * all resources may be closed here. Collections may be also cleared.
	 * 
	 * @throws DevFailed if something fails during the device object delation.
	 */
	@Delete
	public final void deleteDevice() throws DevFailed {
		xlogger.entry();
		/*----- PROTECTED REGION ID(JDeviceForEvent.deleteDevice) ENABLED START -----*/
		
		//	Put your device clearing code here
		
		/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.deleteDevice
		xlogger.exit();
	}

	/**
	 * Method called before and after command and attribute calls.
	 * @param ctx the invocation context
	 * @throws DevFailed if something fails during the this method execution.
	 */
	@AroundInvoke
	public final void aroundInvoke(final InvocationContext ctx) throws DevFailed {
		xlogger.entry(ctx);
		/*----- PROTECTED REGION ID(JDeviceForEvent.aroundInvoke) ENABLED START -----*/
		
		//	Put aroundInvoke code here
		
		/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.aroundInvoke
		xlogger.exit();
	}

	
	/**
	 * dynamic command and attribute management. Will be injected by the framework.
	 */
	@DynamicManagement
	private DynamicManager dynamicManager;
	/**
	 * @param dynamicManager the DynamicManager instance 
	 */
	public void setDynamicManager(final DynamicManager dynamicManager) {
		this.dynamicManager = dynamicManager;
		/*----- PROTECTED REGION ID(JDeviceForEvent.setDynamicManager) ENABLED START -----*/
		
		//	Put your code here
		
		/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.setDynamicManager
	}


	//========================================================
	//	Attribute data members and related methods
	//========================================================
	/**
	 * Attribute Speed, double, Scalar, READ_WRITE
	 * description:
	 *     
	 */
	@Attribute(name="Speed", isPolled=true, pollingPeriod=3000, pushChangeEvent = false, checkChangeEvent = true)
	@AttributeProperties(changeEventAbsolute = "1")
	private double speed;
	/**
	 * Read attribute Speed
	 * 
	 * @return attribute value
	 */
	public double getSpeed() {
		xlogger.entry();
		/*----- PROTECTED REGION ID(JDeviceForEvent.getSpeed) ENABLED START -----*/
		
		//	Put read attribute code here
		
		/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.getSpeed
		xlogger.exit();
		return speed;
	}
	/**
	 * Write attribute Speed
	 * @param  speed value to write
	 */
	public void setSpeed(double speed){
		xlogger.entry();
		/*----- PROTECTED REGION ID(JDeviceForEvent.setSpeed) ENABLED START -----*/
		
		//	Put write attribute code here
		this.speed = speed;
		
		/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.setSpeed
		xlogger.exit();
	}
	

	//========================================================
	//	Command data members and related methods
	//========================================================
	/**
	 * The state of the device
	*/
	@State
	private DevState state = DevState.UNKNOWN;
	/**
	 * Execute command "State".
	 * description: This command gets the device state (stored in its 'state' data member) and returns it to the caller.
	 * @return Device state
	 * @throws DevFailed if command execution failed.
	 */
	public final DevState getState() throws DevFailed {
		/*----- PROTECTED REGION ID(JDeviceForEvent.getState) ENABLED START -----*/
		
		//	Put state code here
		
		/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.getState
		return state;
	}
	/**
	 * Set the device state
	 * @param state the new device state
	 */
	public void setState(final DevState state) {
		this.state = state;
	}
	
	/**
	 * The status of the device
	 */
	@Status
	private String status = "Server is starting. The device state is unknown";
	/**
	 * Execute command "Status".
	 * description: This command gets the device status (stored in its 'status' data member) and returns it to the caller.
	 * @return Device status
	 * @throws DevFailed if command execution failed.
	 */
	public final String getStatus() throws DevFailed {
		/*----- PROTECTED REGION ID(JDeviceForEvent.getStatus) ENABLED START -----*/
		
		//	Put status code here
		
		/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.getStatus
		return status;
	}
	/**
	 * Set the device status
	 * @param status the new device status
	 */
	public void setStatus(final String status) {
		this.status = status;
	}
	

	//========================================================
	//	Programmer's methods
	//========================================================
	/*----- PROTECTED REGION ID(JDeviceForEvent.methods) ENABLED START -----*/
	
	//	Put your own methods here
	
	/*----- PROTECTED REGION END -----*/	//	JDeviceForEvent.methods


	
	
	
	
	/**
	 * Starts the server.
	 * @param args program arguments (instance_name [-v[trace level]]  [-nodb [-dlist <device name list>] [-file=fileName]])
	 */
	public static void main(final String[] args) {
		ServerManager.getInstance().start(args, JDeviceForEvent.class);
		System.out.println("------- Started -------------");
	}
}
